import randomGenerator from "@/classes/Service/Generators/RandomGenerator"

export class DocumentNumberGenerator {
  letters: Array<string> = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"]
  letterValues: Record<string, number> = {
    A: 10,
    B: 11,
    C: 12,
    D: 13,
    E: 14,
    F: 15,
    G: 16,
    H: 17,
    I: 18,
    J: 19,
    K: 20,
    L: 21,
    M: 22,
    N: 23,
    O: 24,
    P: 25,
    Q: 26,
    R: 27,
    S: 28,
    T: 29,
    U: 30,
    V: 31,
    W: 32,
    X: 33,
    Y: 34,
    Z: 35
  }

  generate () {
    var e = this.getLetterPart()
      , t = this.getDigitPart();
    return e + this.getControlSum(e, t) + t
  }

  getLetterPart () {
    for (var e = "", t = 0; t < 3; t++)
      e += this.letters[Math.floor(Math.random() * this.letters.length)];
    return e
  }

  getDigitPart () {
    return randomGenerator.generate(1, 99999).toString().padStart(5, "0")
  }

  getControlSum (e: Record<number, any>, t: Record<number, any>) {
    return String((7 * this.letterValues[e[0]] + 3 * this.letterValues[e[1]] + this.letterValues[e[2]] + 7 * +t[0] + 3 * +t[1] + +t[2] + 7 * +t[3] + 3 * +t[4]) % 10)
  }
}

export default new DocumentNumberGenerator()
