import { flow, useStub } from '@/stubs/config'
import map from '@/stubs/Stub2Flow'

export class StubResolver {
  handle (routeCode: string): Promise<any> | null {
    if (!useStub) {
      return null
    }
    const hasFlow = flow in map || false
    if (!hasFlow) {
      throw new Error('Flow not found!!! Change flow in @/stubs/config.ts')
    }
    const availableStubs = map[flow]
    const hasRoute = routeCode in availableStubs || false
    if (!hasRoute) {
      throw new Error('Route`s stub not found!!! Add stub or change flow to check application')
    }

    return availableStubs[routeCode]
    // return new Promise(() => {})
  }
}

export default new StubResolver()
